use diesel::prelude::*;

use crate::schema::*;

#[derive(Clone, Queryable, Selectable)]
#[diesel(table_name = users)]
#[diesel(check_for_backend(diesel::sqlite::Sqlite))]
pub struct User {
    pub id: i64,
    pub username: String,
    pub password_hash: String,
}

#[derive(Insertable)]
#[diesel(table_name = users)]
#[diesel(check_for_backend(diesel::sqlite::Sqlite))]
pub struct NewUser<'a> {
    pub username: &'a str,
    pub password_hash: &'a str,
}

// impl NewUser {
//     pub fn new(username: String, password: String) -> Self {
//         Self {
//             username,
//             password_hash: hash_password(&password),
//         }
//     }
// }

// impl User {
//     pub fn by_username(pool: &DbPool, username: impl AsRef<str>) -> DbResult<Option<Self>> {
//         Ok(users::dsl::users
//             .select(User::as_select())
//             .filter(users::username.eq(username.as_ref()))
//             .first(&mut pool.get()?)
//             .optional()?)
//     }

//     pub fn verify_password(&self, password: impl AsRef<str>) -> bool {
//         let password_hash = PasswordHash::new(&self.password_hash).unwrap();

//         Argon2::default()
//             .verify_password(password.as_ref().as_bytes(), &password_hash)
//             .is_ok()
//     }
// }
