mod auth;
mod device;
mod episode_action;
mod subscription;

use std::path::Path;

use super::DbPool;

#[derive(Clone)]
pub struct SqliteRepository {
    pool: DbPool,
}

impl From<DbPool> for SqliteRepository {
    fn from(value: DbPool) -> Self {
        Self { pool: value }
    }
}

impl SqliteRepository {
    pub fn from_path(path: impl AsRef<Path>) -> Result<Self, gpodder::AuthErr> {
        let pool = super::initialize_db(path, true)?;

        Ok(Self { pool })
    }
}
