mod auth;
mod devices;
mod episodes;
mod subscriptions;
mod sync;

use axum::Router;

use crate::server::Context;

pub fn router(ctx: Context) -> Router<Context> {
    Router::new()
        .nest("/auth", auth::router())
        .nest("/devices", devices::router(ctx.clone()))
        .nest("/subscriptions", subscriptions::router(ctx.clone()))
        .nest("/episodes", episodes::router(ctx.clone()))
        .nest("/sync-devices", sync::router(ctx.clone()))
}
